标签:dp 数学 codeforces
题目链接:http://codeforces.com/problemset/problem/148/D
The dragon and the princess are arguing about what to do on the New Year‘s Eve. The dragon suggests flying to the mountains to watch fairies dancing in the moonlight, while the princess thinks they should just go to bed early. They are desperate to come to an amicable agreement, so they decide to leave this up to chance.
They take turns drawing a mouse from a bag which initially contains w white and b black mice. The person who is the first to draw a white mouse wins. After each mouse drawn by the dragon the rest of mice in the bag panic, and one of them jumps out of the bag itself (the princess draws her mice carefully and doesn‘t scare other mice). Princess draws first. What is the probability of the princess winning?
If there are no more mice in the bag and nobody has drawn a white mouse, the dragon wins. Mice which jump out of the bag themselves are not considered to be drawn (do not define the winner). Once a mouse has left the bag, it never returns to it. Every mouse is drawn from the bag with the same probability as every other one, and every mouse jumps out of the bag with the same probability as every other one.
The only line of input data contains two integers w and b (0?≤?w,?b?≤?1000).
Output the probability of the princess winning. The answer is considered to be correct if its absolute or relative error does not exceed10?-?9.
1 3
0.500000000
5 5
0.658730159
Let‘s go through the first sample. The probability of the princess drawing a white mouse on her first turn and winning right away is 1/4. The probability of the dragon drawing a black mouse and not winning on his first turn is 3/4 * 2/3 = 1/2. After this there are two mice left in the bag — one black and one white; one of them jumps out, and the other is drawn by the princess on her second turn. If the princess‘ mouse is white, she wins (probability is 1/2 * 1/2 = 1/4), otherwise nobody gets the white mouse, so according to the rule the dragon wins.
题意:
袋子里开始有 w 只白鼠和 b 只黑鼠。王妃和龙轮流从袋子里抓老鼠。谁先抓到白色老鼠谁就赢。
王妃每次抓一只老鼠,龙每次抓完一只老鼠之后会有一只老鼠跑出来。每次抓的老鼠和跑出来的老鼠都是随机的。
如果两个人都没有抓到白色老鼠则龙赢。
王妃先抓。求王妃赢的概率。
PS:http://www.cnblogs.com/kuangbin/archive/2012/10/04/2711184.html
设dp[i][j]表示现在轮到王妃抓时有i只白鼠,j只黑鼠,王妃赢的概率;
明显 dp[0][j] = 0, 0<=j<=b;
因为没有白色老鼠了
dp[i][0] = 1, 1<=i<=w;
因为都是白色老鼠,抓一次肯定赢了。
dp[i][j]可以转化成下列四种状态:
1、王妃抓到一只白鼠,则王妃赢了,概率为i/(i+j);
2、王妃抓到一只黑鼠,龙抓到一只白色,则王妃输了,概率为j/(i+j)*i/(i+j-1).
3、王妃抓到一只黑鼠,龙抓到一只黑鼠,跑出来一只黑鼠,则转移到dp[i][j-3]。
概率为j/(i+j)*(j-1)/(i+j-1)*(j-2)/(i+j-2);
4、王妃抓到一只黑鼠,龙抓到一只黑鼠,跑出来一只白鼠,则转移到dp[i-1][j-2].
概率为j/(i+j)*(j-1)/(i+j-1)*i/(i+j-2);
当然后面两种情况要保证合法,即第三种情况要至少3只黑鼠,第四种情况要至少2只白鼠
代码如下:
#include <cstdio> #include <cstring> #define maxn 1017 double dp[maxn][maxn]; //dp[i][j] :现在有i只白鼠j只黑鼠王妃赢得概率 int main() { int w, b; while(~scanf("%d%d",&w,&b)) { memset(dp, 0,sizeof(dp)); for(int i = 1; i <= w; i++) { dp[i][0] = 1;//全是白鼠 } for(int i = 0; i <= b; i++) { dp[0][i] = 0;//全是黑鼠 } for(int i = 1; i <= w; i++) { for(int j = 1; j <= b; j++) { // if(i==0 && j==0) // continue; //王妃直接抓到白鼠 dp[i][j] += (double)i/(i+j); //王妃和龙都抓的黑鼠,随机跑出来的也是黑鼠 if(j >= 3) dp[i][j] += (double)j/(i+j)*(double)(j-1)/(i+j-1)*(double)(j-2)/(i+j-2)*dp[i][j-3]; //王妃和龙都抓的黑鼠,随机跑出来的是白鼠 if(i>=1 && j>=2) dp[i][j] += (double)j/(i+j)*(double)(j-1)/(i+j-1)*(double)(i)/(i+j-2)*dp[i-1][j-2]; } } printf("%.9lf\n",dp[w][b]); } return 0; }
CodeForces 148D. Bag of mice(概率dp啊 )
标签:dp 数学 codeforces
原文地址:http://blog.csdn.net/u012860063/article/details/43702983